diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFlame.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFlame.java
index 19b708ded..a2fc5df57 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFlame.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFlame.java
@@ -4,6 +4,7 @@ import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.tessellator.TessellatorParticle;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
@@ -40,13 +41,13 @@ public class ParticleFlame extends Particle {
     }
 
     @Override
-    public int calcLightmap(float partialTick) {
-        return LightmapHelper.setBlocklightValue(super.calcLightmap(partialTick), 15);
+    public byte calcLightIndex(float partialTick) {
+        return LightIndexHelper.setBlockLight(super.calcLightIndex(partialTick), 15);
     }
 
     @Override
     public void tick() {
-        this.cachedLightmapCoord = calcLightmap(1f);
+        this.cachedLightmapCoord = calcLightIndex(1f);
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFluidDrip.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFluidDrip.java
index 1a8f9e816..01c99d495 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFluidDrip.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFluidDrip.java
@@ -1,11 +1,11 @@
 package net.minecraft.client.render.particle;
 
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.ParticleEngine;
 import net.minecraft.client.render.tessellator.TessellatorParticle;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.Color;
+import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
@@ -34,7 +34,7 @@ public class ParticleFluidDrip extends Particle {
 
     @Override
     public void tick() {
-        this.cachedLightmapCoord = calcLightmap(1f);
+        this.cachedLightmapCoord = calcLightIndex(1f);
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
@@ -61,7 +61,7 @@ public class ParticleFluidDrip extends Particle {
     @Override
     public void render(@NotNull TessellatorParticle t, float partialTick) {
         if (this.tex == null) return;
-        t.setLightmapCoord1i(getLightmap(partialTick));
+        t.setLightmapCoord1i(getLightIndex(partialTick));
         t.setColorOpaque3f(this.rCol, this.gCol, this.bCol);
         t.addParticle(
             MathHelper.lerp(this.xo, this.x, partialTick),
@@ -82,10 +82,10 @@ public class ParticleFluidDrip extends Particle {
     }
 
     @Override
-    public int calcLightmap(float partialTick) {
+    public byte calcLightIndex(float partialTick) {
         if (this.fullBright) {
-            return LightmapHelper.getOverbrightLightmapCoord(this.world.getSavedLightValue(LightLayer.Sky, new TilePos(this.x, this.y, this.z)));
+            return LightIndexHelper.lightIndex2i(this.world.getSavedLightValue(LightLayer.Sky, new TilePos(this.x, this.y, this.z)), 15);
         }
-        return super.calcLightmap(partialTick);
+        return super.calcLightIndex(partialTick);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFootstep.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFootstep.java
index f37a469dc..a92333e3c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFootstep.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFootstep.java
@@ -55,7 +55,7 @@ public class ParticleFootstep extends Particle {
 
     @Override
     public void tick() {
-        this.cachedLightmapCoord = calcLightmap(1f);
+        this.cachedLightmapCoord = calcLightIndex(1f);
         this.life++;
         if (this.life == this.lifeTime) {
             this.remove();
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleHeart.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleHeart.java
index eb7478e3d..3e3255b48 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleHeart.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleHeart.java
@@ -41,7 +41,7 @@ public class ParticleHeart extends Particle {
 
     @Override
     public void tick() {
-        this.cachedLightmapCoord = calcLightmap(1f);
+        this.cachedLightmapCoord = calcLightIndex(1f);
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleItemBreaking.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleItemBreaking.java
index e7bdc13e4..7125f5740 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleItemBreaking.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleItemBreaking.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render.particle;
 
-import net.minecraft.client.render.ParticleEngine;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.tessellator.TessellatorParticle;
 import net.minecraft.core.block.Blocks;
@@ -21,7 +20,7 @@ public class ParticleItemBreaking extends Particle {
     @Override
     public void render(@NotNull TessellatorParticle t, float partialTick) {
         if (this.tex == null) return;
-        t.setLightmapCoord1i(getLightmap(partialTick));
+        t.setLightmapCoord1i(getLightIndex(partialTick));
         t.setColorOpaque3f(this.rCol, this.gCol, this.bCol);
         t.addParticle(MathHelper.lerp(this.xo, this.x, partialTick),
             MathHelper.lerp(this.yo, this.y, partialTick),
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLava.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLava.java
index b8aff2cfe..e126295de 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLava.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLava.java
@@ -36,7 +36,7 @@ public class ParticleLava extends Particle {
 
     @Override
     public void tick() {
-        this.cachedLightmapCoord = calcLightmap(1f);
+        this.cachedLightmapCoord = calcLightIndex(1f);
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLeaf.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLeaf.java
index 0a8577142..174fa6963 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLeaf.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLeaf.java
@@ -39,7 +39,7 @@ public class ParticleLeaf extends Particle {
 
     @Override
     public void tick() {
-        this.cachedLightmapCoord = calcLightmap(1f);
+        this.cachedLightmapCoord = calcLightIndex(1f);
         float windDirection = this.world.worldType.getWindManager().getWindDirection(this.world, (float) this.x, (float) this.y, (float) this.z);
         float windIntensity = this.world.worldType.getWindManager().getWindIntensity(this.world, (float) this.x, (float) this.y, (float) this.z) * 0.01f;
 
@@ -66,7 +66,7 @@ public class ParticleLeaf extends Particle {
     @Override
     public void render(@NotNull TessellatorParticle t, float partialTick) {
         if (this.tex == null) return;
-        t.setLightmapCoord1i(getLightmap(partialTick));
+        t.setLightmapCoord1i(getLightIndex(partialTick));
         t.setColorOpaque3f(this.rCol, this.gCol, this.bCol);
         t.addParticle(
             MathHelper.lerp(this.xo, this.x, partialTick),
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleNote.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleNote.java
index dec30e89f..15338e4c7 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleNote.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleNote.java
@@ -46,7 +46,7 @@ public class ParticleNote extends Particle {
 
     @Override
     public void tick() {
-        this.cachedLightmapCoord = calcLightmap(1f);
+        this.cachedLightmapCoord = calcLightIndex(1f);
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePickupAnimation.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePickupAnimation.java
index b2aa91c2f..b7afd1cbc 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePickupAnimation.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePickupAnimation.java
@@ -42,14 +42,14 @@ public class ParticlePickupAnimation extends Particle {
         xx -= xOff;
         yy -= yOff;
         zz -= zOff;
-        GLRenderer.setLightmapCoord1i(this.item.world.getLightmapCoord(tilePos, 0));
+        GLRenderer.setLightmapCoord1i(this.item.world.getLightIndex(tilePos, 0));
         GLRenderer.setColor4f(1f, 1f, 1f, 1f);
         EntityRendererDispatcher.instance.renderEntityWithPosYaw(t, this.item, (float) xx, (float) yy, (float) zz, this.item.yRot, partialTick);
     }
 
     @Override
     public void tick() {
-        this.cachedLightmapCoord = calcLightmap(1f);
+        this.cachedLightmapCoord = calcLightIndex(1f);
         this.life++;
         if (this.life == this.lifeTime) {
             remove();
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePortal.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePortal.java
index 6019c3626..eaaa968d6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePortal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePortal.java
@@ -54,7 +54,7 @@ public class ParticlePortal extends Particle {
 
     @Override
     public void tick() {
-        this.cachedLightmapCoord = calcLightmap(1f);
+        this.cachedLightmapCoord = calcLightIndex(1f);
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePuffRGB.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePuffRGB.java
index 41d456651..a0adf6a45 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePuffRGB.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePuffRGB.java
@@ -1,9 +1,9 @@
 package net.minecraft.client.render.particle;
 
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.tessellator.TessellatorParticle;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.enums.LightLayer;
+import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
@@ -53,9 +53,9 @@ public class ParticlePuffRGB extends Particle {
         int zTile = MathHelper.floor(this.z);
         int lmc;
         if (this.brightness >= 0) {
-            lmc = LightmapHelper.getLightmapCoord(this.world.getSavedLightValue(LightLayer.Sky, xTile, yTile, zTile), Math.max(this.world.getSavedLightValue(LightLayer.Block, xTile, yTile, zTile), this.brightness));
+            lmc = LightIndexHelper.lightIndex2i(this.world.getSavedLightValue(LightLayer.Sky, xTile, yTile, zTile), Math.max(this.world.getSavedLightValue(LightLayer.Block, xTile, yTile, zTile), this.brightness));
         } else {
-            lmc = getLightmap(partialTick);
+            lmc = getLightIndex(partialTick);
         }
         t.setLightmapCoord1i(lmc);
         t.setColorOpaque3f(this.rCol, this.gCol, this.bCol);
@@ -68,7 +68,7 @@ public class ParticlePuffRGB extends Particle {
 
     @Override
     public void tick() {
-        this.cachedLightmapCoord = calcLightmap(1f);
+        this.cachedLightmapCoord = calcLightIndex(1f);
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleRedstoneDust.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleRedstoneDust.java
index 97c8ee12e..d3f35182f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleRedstoneDust.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleRedstoneDust.java
@@ -6,6 +6,7 @@ import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.Color;
+import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
@@ -61,9 +62,9 @@ public class ParticleRedstoneDust extends Particle {
         int zTile = MathHelper.floor(this.z);
         int lmc;
         if (this.brightness >= 0) {
-            lmc = LightmapHelper.getLightmapCoord(this.world.getSavedLightValue(LightLayer.Sky, xTile, yTile, zTile), Math.max(this.world.getSavedLightValue(LightLayer.Block, xTile, yTile, zTile), this.brightness));
+            lmc = LightIndexHelper.lightIndex2i(this.world.getSavedLightValue(LightLayer.Sky, xTile, yTile, zTile), Math.max(this.world.getSavedLightValue(LightLayer.Block, xTile, yTile, zTile), this.brightness));
         } else {
-            lmc = getLightmap(partialTick);
+            lmc = getLightIndex(partialTick);
         }
         t.setLightmapCoord1i(lmc);
         t.setColorOpaque3f(this.rCol, this.gCol, this.bCol);
@@ -78,7 +79,7 @@ public class ParticleRedstoneDust extends Particle {
 
     @Override
     public void tick() {
-        this.cachedLightmapCoord = calcLightmap(1f);
+        this.cachedLightmapCoord = calcLightIndex(1f);
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSlimeChunk.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSlimeChunk.java
index edc08c51d..d83182881 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSlimeChunk.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSlimeChunk.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render.particle;
 
-import net.minecraft.client.render.ParticleEngine;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.tessellator.TessellatorParticle;
 import net.minecraft.core.item.Item;
@@ -22,7 +21,7 @@ public class ParticleSlimeChunk extends Particle {
     public void render(@NotNull TessellatorParticle t, float partialTick) {
         if (this.tex == null) return;
         float br = 1.0f;
-        t.setLightmapCoord1i(getLightmap(partialTick));
+        t.setLightmapCoord1i(getLightIndex(partialTick));
         t.setColorOpaque3f(this.rCol * br, this.gCol * br, this.bCol * br);
         t.addParticle(MathHelper.lerp(this.xo, this.x, partialTick),
             MathHelper.lerp(this.yo, this.y, partialTick),
diff --git a/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java b/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java
index 25868a062..78e748be1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java
@@ -5,14 +5,20 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.FogManager;
 import net.minecraft.client.render.Lighting;
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.shader.Shader;
 import net.minecraft.client.render.tessellator.RenderBuffer;
 import net.minecraft.client.render.tessellator.TessellatorShader;
 import net.minecraft.client.render.uniform.UniformBlockManager;
 import net.minecraft.core.util.helper.Color;
+import net.minecraft.core.util.helper.LightIndexHelper;
 import org.jetbrains.annotations.NotNull;
-import org.joml.*;
+import org.joml.Matrix4f;
+import org.joml.Matrix4fStack;
+import org.joml.Vector3dc;
+import org.joml.Vector3fc;
+import org.joml.Vector4dc;
+import org.joml.Vector4f;
+import org.joml.Vector4fc;
 import org.lwjgl.BufferUtils;
 import org.lwjgl.opengl.GL41;
 import org.slf4j.Logger;
@@ -112,10 +118,8 @@ public class GLRenderer {
     private float currentPolygonFactor = 0f;
     private float currentPolygonUnits = 0f;
 
-    private final float[] lightmapBlockStack = new float[RENDER_FRAMES_STACK_SIZE];
-    private final float[] lightmapSkyStack = new float[RENDER_FRAMES_STACK_SIZE];
-    private float currentLightmapBlock = 15.5f/16f;
-    private float currentLightmapSky = 15.5f/16f;
+    private final byte[] lightIndexStack = new byte[RENDER_FRAMES_STACK_SIZE];
+    private byte currentLightIndex = LightIndexHelper.lightIndex2i(15, 15);
 
     private final float[] alphaTestStack = new float[RENDER_FRAMES_STACK_SIZE];
     private float currentAlphaTest = 0.1f;
@@ -134,7 +138,6 @@ public class GLRenderer {
 
     }
 
-    private static final FloatBuffer lightBuf = BufferUtils.createFloatBuffer(8);
     private static final Matrix4f matBuf = new Matrix4f();
     public static void globalSetUniforms(@NotNull Shader shader) {
         shader.bind();
@@ -324,25 +327,20 @@ public class GLRenderer {
         return instance.currentPolygonUnits;
     }
 
-    public static void setLightmapCoord1i(int lightmapCoord) {
-        setLightmapCoord2i(LightmapHelper.getBlockLightFromCoord(lightmapCoord), LightmapHelper.getSkyLightFromCoord(lightmapCoord));
+    public static void setLightmapCoord1i(int lightIndex) {
+        instance.currentLightIndex = (byte) lightIndex;
     }
 
-    public static void setLightmapCoord2i(int blockLight, int skyLight) {
-        setLightmapCoord2f((blockLight + 0.5f) / 16f, (skyLight + 0.5f) / 16f);
+    public static void setLightmapCoord2i(int skyLight, int blockLight) {
+        setLightmapCoord1i(LightIndexHelper.lightIndex2i(skyLight, blockLight));
     }
 
-    public static void setLightmapCoord2f(float blockLight, float skyLight) {
-        instance.currentLightmapBlock = blockLight;
-        instance.currentLightmapSky = skyLight;
+    public static void setLightmapCoord2f(float skyLight, float blockLight) {
+        setLightmapCoord1i(LightIndexHelper.lightIndex2f(skyLight, blockLight));
     }
 
-    public static float getLightmapBlock() {
-        return instance.currentLightmapBlock;
-    }
-
-    public static float getLightmapSky() {
-        return instance.currentLightmapSky;
+    public static byte getLightIndex() {
+        return instance.currentLightIndex;
     }
 
     public static void setAlphaTest(float alphaTest) {
@@ -423,8 +421,7 @@ public class GLRenderer {
         instance.depthMaskStack[instance.stackIndex] = instance.currentDepthMask;
         instance.polygonFactorStack[instance.stackIndex] = instance.currentPolygonFactor;
         instance.polygonUnitsStack[instance.stackIndex] = instance.currentPolygonUnits;
-        instance.lightmapBlockStack[instance.stackIndex] = instance.currentLightmapBlock;
-        instance.lightmapSkyStack[instance.stackIndex] = instance.currentLightmapSky;
+        instance.lightIndexStack[instance.stackIndex] = instance.currentLightIndex;
         instance.alphaTestStack[instance.stackIndex] = instance.currentAlphaTest;
 
         if (DEBUG) {
@@ -524,8 +521,7 @@ public class GLRenderer {
             GL41.glPolygonOffset(instance.currentPolygonFactor, instance.currentPolygonUnits);
         }
 
-        instance.currentLightmapBlock = instance.lightmapBlockStack[instance.stackIndex];
-        instance.currentLightmapSky = instance.lightmapSkyStack[instance.stackIndex];
+        instance.currentLightIndex = instance.lightIndexStack[instance.stackIndex];
         instance.currentAlphaTest = instance.alphaTestStack[instance.stackIndex];
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/renderer/Shaders.java b/game/client/src/main/java/net/minecraft/client/render/renderer/Shaders.java
index 248d155e0..a7501c872 100644
--- a/game/client/src/main/java/net/minecraft/client/render/renderer/Shaders.java
+++ b/game/client/src/main/java/net/minecraft/client/render/renderer/Shaders.java
@@ -25,7 +25,8 @@ public final class Shaders {
     public static final @NotNull Shader WORLD = register("world", new Shader());
     public static final @NotNull Shader AURORA = register("aurora", new Shader());
     public static final @NotNull Shader ENTITY = register("entity", new Shader());
-    public static final @NotNull Shader TERRAIN = register("terrain", new Shader());
+    public static final @NotNull Shader TERRAIN = register("terrain", new ShaderGeometry());
+    public static final @NotNull Shader ITEM = register("item", new Shader());
     public static final @NotNull Shader INTERFACE = register("interface", new Shader());
     public static final @NotNull Shader COLOR = register("color", new Shader());
     public static final @NotNull Shader COLOR_WORLD = register("color_world", new Shader());
@@ -33,6 +34,7 @@ public final class Shaders {
     public static final @NotNull ShaderGeometry PARTICLE = register("particle", new ShaderGeometry());
     public static final @NotNull ShaderGeometry FONT = register("font", new ShaderGeometry());
     public static final @NotNull ShaderGeometry LINES = register("lines", new ShaderGeometry());
+    public static final @NotNull ShaderGeometry LOD = register("lod", new ShaderGeometry());
 
     public static @NotNull <T extends Shader> T register(@NotNull String id, @NotNull T shader) {
         if (!ALL_SHADERS.contains(shader)) ALL_SHADERS.add(shader);
@@ -51,7 +53,7 @@ public final class Shaders {
                 entry.getValue().uniformInt("colortex", 0);
                 entry.getValue().uniformInt("lighttex", 1);
                 entry.getValue().uniformInt("emmisivetex", 2);
-//                entry.getValue().uniformInt("colormasktex", 3);
+                entry.getValue().uniformInt("colormasktex", 3);
                 GL41.glUseProgram(0);
             } catch (Exception e) {
                 LOGGER.error("", e);
@@ -73,7 +75,7 @@ public final class Shaders {
                 entry.getValue().uniformInt("colortex", 0);
                 entry.getValue().uniformInt("lighttex", 1);
                 entry.getValue().uniformInt("emmisivetex", 2);
-//                entry.getValue().uniformInt("colormasktex", 3);
+                entry.getValue().uniformInt("colormasktex", 3);
                 GL41.glUseProgram(0);
             } catch (Exception e) {
                 LOGGER.error("", e);
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
index 3a1a5a151..ccce9eb04 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
@@ -3,15 +3,13 @@ package net.minecraft.client.render.terrain;
 import java.util.ArrayList;
 import java.util.List;
 
-import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3i;
 import org.joml.primitives.AABBd;
 
-import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.culling.CameraFrustum;
 import net.minecraft.core.entity.Entity;
@@ -22,88 +20,73 @@ public abstract class ChunkRenderer {
     public static final int MAX_RENDER_PASSES = 2;
     public static int updates = 0;
 
-    public World world;
-    public int posX;
-    public int posY;
-    public int posZ;
-    public int sizeX;
-    public int sizeY;
-    public int sizeZ;
-    public int xRender;
-    public int yRender;
-    public int zRender;
-    public int xRenderOffs;
-    public int yRenderOffs;
-    public int zRenderOffs;
-    public boolean visible;
-    public boolean[] empty;
-    public int xm;
-    public int ym;
-    public int zm;
-    public float radius;
-    public boolean dirty;
-    public AABBd bb;
-    public int id;
-    public boolean skyLit;
-    protected boolean compiled;
-    public @NotNull List<@NotNull TileEntity> renderableBlockEntities;
+    public final boolean @NotNull [] empty = new boolean[MAX_RENDER_PASSES];
+
+    public boolean visible = false;
+    public int id = -1;
+
+    protected final @NotNull TilePos pos = new TilePos();
+    protected final @NotNull Vector3i size = new Vector3i();
+    protected final @NotNull List<@NotNull TileEntity> renderableBlockEntities = new ArrayList<>();
     protected final @NotNull List<@NotNull TileEntity> globalRenderableBlockEntities;
+    protected boolean compiled = false;
 
-    public ChunkRenderer(@NotNull World world, @NotNull List<@NotNull TileEntity> globalRenderableTileEntities, int x, int y, int z, int size) {
-        this.visible = false;
-        this.empty = new boolean[MAX_RENDER_PASSES];
-        this.compiled = false;
-        this.renderableBlockEntities = new ArrayList<>();
+    private final @NotNull Vector3i middlePos = new Vector3i();
+    private final @NotNull AABBd bb = new AABBd();
+
+    private @Nullable World world;
+    private boolean dirty = true;
+
+    public ChunkRenderer(
+        final @NotNull World world,
+        final @NotNull List<@NotNull TileEntity> globalRenderableTileEntities,
+        final int x, final int y, final int z,
+        final int size
+    ) {
         this.world = world;
         this.globalRenderableBlockEntities = globalRenderableTileEntities;
-        this.sizeX = this.sizeY = this.sizeZ = size;
-        this.radius = MathHelper.sqrt_float(this.sizeX * this.sizeX + this.sizeY * this.sizeY + this.sizeZ * this.sizeZ) / 2.0F;
-        this.posX = -999;
-        setPos(x, y, z);
-        this.dirty = false;
+        this.size.set(size);
+        this.setPosInner(x, y, z);
     }
 
-    public void setPos(int x, int y, int z) {
-        if (x != this.posX || y != this.posY || z != this.posZ) {
-            reset();
-            this.posX = x;
-            this.posY = y;
-            this.posZ = z;
-            this.xm = x + this.sizeX / 2;
-            this.ym = y + this.sizeY / 2;
-            this.zm = z + this.sizeZ / 2;
-            this.xRenderOffs = x & 0x3ff;
-            this.yRenderOffs = y;
-            this.zRenderOffs = z & 0x3ff;
-            this.xRender = x - this.xRenderOffs;
-            this.yRender = y - this.yRenderOffs;
-            this.zRender = z - this.zRenderOffs;
-            float f = 6F;
-            this.bb = new AABBd(x - f, y - f,  z - f, (x + this.sizeX) + f, (y + this.sizeY) + f, (z + this.sizeZ) + f);
-            setDirty();
-        }
+    public @NotNull World getWorld() {
+        assert this.world != null;
+        return this.world;
     }
 
-    public abstract boolean rebuild(boolean priority);
+    public void setPos(final int x, final int y, final int z) {
+        if (x != this.pos.x || y != this.pos.y || z != this.pos.z) {
+            this.reset();
+            this.setPosInner(x, y, z);
+            this.setDirty(true);
+        }
+    }
 
-    public boolean renderBlock(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull BlockModel<?> model, @NotNull TilePos tilePos) {
-        tessellator.setLightmapCoord1i(LightmapHelper.getLightmapCoord(15, 15));
-        tessellator.setColor4i(255, 255, 255, 255);
-        tessellator.setTextureUV(0.0, 0.0);
-        return model.render(tessellator, worldSource, tilePos);
+    private void setPosInner(final int x, final int y, final int z) {
+        this.pos.x = x;
+        this.pos.y = y;
+        this.pos.z = z;
+        this.middlePos.x = x + this.size.y / 2;
+        this.middlePos.y = y + this.size.y / 2;
+        this.middlePos.z = z + this.size.z / 2;
+        final float radius = 6F;
+        this.bb.setMin(x - radius, y - radius, z - radius);
+        this.bb.setMax((x + this.size.x) + radius, (y + this.size.y) + radius, (z + this.size.z) + radius);
     }
 
-    public float distanceToEntitySquared(Entity entity) {
-        float dx = (float) (entity.x - (double) this.xm);
-        float dy = (float) (entity.y - (double) this.ym);
-        float dz = (float) (entity.z - (double) this.zm);
+    public abstract boolean rebuild(boolean priority);
+
+    public float distanceToEntitySquared(final @NotNull Entity entity) {
+        final float dx = (float) (entity.x - this.middlePos.x);
+        final float dy = (float) (entity.y - this.middlePos.y);
+        final float dz = (float) (entity.z - this.middlePos.z);
         return dx * dx + dy * dy + dz * dz;
     }
 
-    public float distanceToCameraSquared(ICamera camera) {
-        float dx = (float) (camera.getX(1f) - this.xm);
-        float dy = (float) (camera.getY(1f) - this.ym);
-        float dz = (float) (camera.getZ(1f) - this.zm);
+    public float distanceToCameraSquared(final @NotNull ICamera camera) {
+        final float dx = (float) (camera.getX(1f) - this.middlePos.x);
+        final float dy = (float) (camera.getY(1f) - this.middlePos.y);
+        final float dz = (float) (camera.getZ(1f) - this.middlePos.z);
         return dx * dx + dy * dy + dz * dz;
     }
 
@@ -117,11 +100,11 @@ public abstract class ChunkRenderer {
     }
 
     public void delete() {
-        reset();
+        this.reset();
         this.world = null;
     }
 
-    public void cull(CameraFrustum frustum, float partialTick) {
+    public void cull(final @NotNull CameraFrustum frustum, final float partialTick) {
         this.visible = frustum.isVisible(this.bb, partialTick);
     }
 
@@ -133,7 +116,11 @@ public abstract class ChunkRenderer {
         }
     }
 
-    public void setDirty() {
-        this.dirty = true;
+    public void setDirty(final boolean dirty) {
+        this.dirty = dirty;
+    }
+
+    public boolean isDirty() {
+        return this.dirty;
     }
 }
